unit ControlPanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TControl_Panel = class(TForm)
    Start_Button: TButton;
    StaticText14: TStaticText;
    StaticText15: TStaticText;
    StaticText16: TStaticText;
    EditX1: TEdit;
    EditX2: TEdit;
    EditY1: TEdit;
    EditY2: TEdit;
    Exit_Button: TButton;
    StaticText1: TStaticText;
    EditR1: TEdit;
    EditR2: TEdit;
    EditS1: TEdit;
    EditS2: TEdit;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    StaticText4: TStaticText;
    EditRovX: TEdit;
    EditRovY: TEdit;
    EditRovZ: TEdit;
    StaticText5: TStaticText;
    StaticText6: TStaticText;
    StaticText11: TStaticText;
    StaticText12: TStaticText;
    StaticText10: TStaticText;
    EditAlfa: TEdit;
    EditBeta: TEdit;
    StaticText7: TStaticText;
    StaticText8: TStaticText;
    StaticText9: TStaticText;
    EditD: TEdit;
    procedure Plocha(Sender: TObject);
    procedure Exit(Sender: TObject);
    procedure SetY2(Sender: TObject);
    procedure SetDraw3D(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Control_Panel: TControl_Panel;

implementation

uses Graph3D_2005;

{$R *.DFM}
procedure TControl_Panel.Plocha(Sender: TObject);
var Code,i     :Integer;
    fx,fy,fz,
    ErrorReport:String;
    Alfa,Beta  :Double; 
    Express_fx,
    Express_fy,
    Express_fz :TExpression;

  Procedure Setting;
  var numer:Double;
  begin
    Val(EditX1.Text,Numer,Code);Draw3D.X1:=Numer;
    Val(EditX2.Text,Numer,Code);Draw3D.X2:=Numer;
    Val(EditY1.Text,Numer,Code);Draw3D.Y1:=Numer;
    Val(EditY2.Text,Numer,Code);Draw3D.Y2:=Numer;
    Val(EditR1.Text,Numer,Code);Draw3D.R1:=Numer;
    Val(EditR2.Text,Numer,Code);Draw3D.R2:=Numer;
    Val(EditS1.Text,Numer,Code);Draw3D.S1:=Numer;
    Val(EditS2.Text,Numer,Code);Draw3D.S2:=Numer;
    fx:=EditRovX.Text;
    fy:=EditRovY.Text;
    fz:=EditRovZ.Text;
    Val(EditD.Text,Numer,Code);Draw3D.ObserverDistance:=Numer;
    Val(EditAlfa.Text,Alfa,Code);
    Val(EditBeta.Text,Beta,Code);
  end;

  begin
    Setting;
    With Draw3D do
    begin
    Visible:=True;ClearImage(255,255,255);
    Scale(x1,x2,y1,y2);
    SetCenterProjection(Alfa,Beta,ObserverDistance,ObserverPoint);
    Red:=255;Green:=0;Blue:=0;
    hr:=(r2-r1)/50;hs:=(s2-s1)/50;
    r:=r1;
    Express_fx:=Precalc(fx,ErrorReport);
    Express_fy:=Precalc(fy,ErrorReport);
    Express_fz:=Precalc(fz,ErrorReport);
    Repeat
      s:=s1;i:=0;
      Repeat
         Q[i,1]:=PostCalc(Express_fx,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);system.exit;end;
         Q[i,2]:=PostCalc(Express_fy,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);system.exit;end;
         Q[i,3]:=PostCalc(Express_fz,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);system.exit;end;
         s:=s+hs;
         i:=succ(i);
      until s>s2;
      PolyLine(Q,i,Red,Green,Blue);
      r:=r+hr;
      Image.Repaint;
      Application.ProcessMessages;
    until r>r2;
    s:=s1;
    Repeat
      r:=r1;i:=0;
      Repeat
         Q[i,1]:=PostCalc(Express_fx,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);system.exit;end;
         Q[i,2]:=PostCalc(Express_fy,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);system.exit;end;
         Q[i,3]:=PostCalc(Express_fz,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);system.exit;end;
         r:=r+hr; i:=succ(i);
      until r>r2;
      PolyLine(Q,i,Red,Green,Blue);
      s:=s+hs;
      Image.Repaint;
      Application.ProcessMessages;
    until s>s2;
  end;
end;

procedure TControl_Panel.Exit(Sender: TObject);
begin
  Draw3D.Visible:=False;
  Halt;
end;
procedure TControl_Panel.SetY2(Sender: TObject);
var x1,x2,y1,y2:Real;
    Code:Integer;
    Vypis:String;
begin
   With Draw3D do
   begin
   Val(EditX1.Text,x1,Code);
   Val(EditX2.Text,x2,Code);
   Val(EditY1.Text,y1,Code);
   y2:=y1+(x2-x1)*ClientHeight/ClientWidth;
   Str(y2:4:2,Vypis);EditY2.Text:=Vypis;
   EditY2.Show;
   end;
end;


procedure TControl_Panel.SetDraw3D(Sender: TObject);
begin
   Application.CreateForm(TDraw3D, Draw3D);
   With Draw3D do
   begin
     Caption:='Central Projection of Parametric Surface';
     Top:=10;Left:=300;
     ClientWidth:=600;ClientHeight:=400;
     InitImage(600,400);ClearImage(255,255,255);
     Visible:=True;
   end;

end;



end.
